
  <!DOCTYPE html>
  <html>
    <head>
      <title>index.tsx</title>
      <link href="https://cdn.jsdelivr.net/npm/semantic-ui@2.4.2/dist/semantic.min.css" type="text/css" rel="stylesheet">
      <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.js" type="text/javascript" charset="utf-8"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/mode/javascript/javascript.min.js" type="text/javascript" charset="utf-8"></script>
<link href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.css" type="text/css" rel="stylesheet">
<script src="../../../../assets/source-file.js" type="text/javascript" charset="utf-8"></script>
<link href="../../../../assets/source-file.css" type="text/css" rel="stylesheet">
    </head>
    <body>
    <div style="margin-top:3em" class="ui container"><h1 class="ui header"><a href="../../../../index.html">TypeScript coverage report</a></h1><table style="margin-top:2em" class="ui celled table"><thead class=""><tr class=""><th class="">Filename</th><th class="">Percent</th><th class="">Threshold</th><th class="">Total</th><th class="">Covered</th><th class="">Uncovered</th></tr></thead><tbody class=""><tr class="positive"><td class="">src/pages/projects/index.tsx</td><td class="">94.64%</td><td class="">80%</td><td class="">261</td><td class="">247</td><td class="">14</td></tr></tbody></table><textarea id="editor" readonly="" style="margin-top:3em">import React, { useEffect, useState } from &#x27;react&#x27;;

import s from &#x27;./projects.module.scss&#x27;;

import { Heading, HeadingVariant } from &#x27;../../components&#x27;;
import { Button, ButtonVariant } from &#x27;../../components/Button/Button&#x27;;
import { ReactComponent as AddIcon } from &#x27;./assets/add.svg&#x27;;
import { ReactComponent as CloneSelectionIcon } from &#x27;./assets/clone-selection.svg&#x27;;
import { ReactComponent as DigitalTwinIcon } from &#x27;./assets/digital-twin.svg&#x27;;
import { ProjectCard } from &#x27;../../components/ProjectCard/ProjectCard&#x27;;
import { Header } from &#x27;../../components/Header/Header&#x27;;
import { Modal } from &#x27;../../components/Modal/Modal&#x27;;
import clsx from &#x27;clsx&#x27;;
import { Link } from &#x27;react-router-dom&#x27;;
import { Paths } from &#x27;../../routes/paths&#x27;;
import { useProjects } from &#x27;../../queries/projects&#x27;;
import { ProjectsApi } from &#x27;../../api/projects&#x27;;

export type TargetRole =
  | &#x27;BatchID&#x27;
  | &#x27;Time&#x27;
  | &#x27;Viable cell density&#x27;
  | &#x27;Cell viability&#x27;
  | &#x27;Titer&#x27;
  | &#x27;Volume&#x27;
  // | &#x27;Bio material&#x27; // Input
  // | &#x27;Effective growth rate&#x27; // Metabolite
  // | &#x27;Feed rate&#x27; // Feed flow
  // | &#x27;feed conc&#x27; // Feed bolus
  | &#x27;Bleed rate&#x27; // Bleed Flow
  | &#x27;Harvest&#x27;; // Harvest Flow;

export const targetRoles: TargetRole[] = [
  &#x27;BatchID&#x27;,
  &#x27;Time&#x27;,
  &#x27;Viable cell density&#x27;,
  &#x27;Cell viability&#x27;,
  &#x27;Titer&#x27;,
  &#x27;Volume&#x27;,
  // &#x27;Feed rate&#x27;, // Feed flow
  // &#x27;feed conc&#x27;, // Feed bolus
  &#x27;Bleed rate&#x27;, // Bleed Flow
  &#x27;Harvest&#x27; // Harvest Flow;
];
export interface Project {
  columns_map: null | { [key in TargetRole]?: string };
  creating_step: string;
  date_created: string;
  date_modified: string;
  id: string;
  initial_data: string;
  name: string;
  type: &#x27;clone selection&#x27; | &#x27;digital twin&#x27;;
  user: string;
}

export const mapRowsToObject = (rows: object[]) =&gt; {
  const keys = rows.reduce((acc, row) =&gt; ({ ...acc, ...row }), {});
  const resObj: any = {};
  Object.keys(keys).forEach((key) =&gt; {
    const data = rows.map((row) =&gt; (row as any)[key]);
    resObj[key] = data.reduce((acc, a, idx) =&gt; ({ ...acc, [idx]: a }), {});
  });
  return resObj;
};

export const mapObjectToRows = (obj: any) =&gt; {
  const keys = Object.keys(obj);

  const objWithKeysNumbers: { [key: string]: boolean } = {};

  keys.forEach((key) =&gt; {
    const objWithNumbersAsKeys = obj[key];
    Object.keys(objWithNumbersAsKeys).forEach((numberAsKey) =&gt; {
      objWithKeysNumbers[numberAsKey] = true;
    });
  });
  const numbers = Object.keys(objWithKeysNumbers);
  return numbers.map((number) =&gt;
    keys.reduce((acc, key) =&gt; {
      return {
        ...acc,
        [key]: obj[key][number]
      };
    }, {})
  );
};
export const ProjectsPage = () =&gt; {
  const [isModalOpen, setModalOpen] = useState(false);

  const { data: projects } = useProjects();
  useEffect(() =&gt; {
    ProjectsApi.rendering();
  }, []);
  const renderQueueProjects = projects.filter((p) =&gt; p.isInRenderQueue);
  return (
    &lt;div&gt;
      &lt;Header /&gt;
      {/* FIXME: сделать плавное открытие */}
      {isModalOpen &amp;&amp; (
        &lt;Modal
          onClose={() =&gt; setModalOpen(false)}
          title=&quot;Select a project type&quot;
        &gt;
          &lt;div className={s.Projects__modalContent}&gt;
            &lt;Link
              to={Paths.CLONE_SELECTION_PROJECT_SETTINGS}
              className={s.Projects__modalContentItem}
            &gt;
              &lt;div className={s.Projects__modalContentItemImg}&gt;
                &lt;CloneSelectionIcon /&gt;
              &lt;/div&gt;
              &lt;div className={s.Projects__modalContentItemName}&gt;
                Clone Selection
              &lt;/div&gt;
            &lt;/Link&gt;
            &lt;Link
              to={Paths.DIGITAL_TWIN_PROJECT_SETTINGS}
              className={s.Projects__modalContentItem}
            &gt;
              &lt;div className={s.Projects__modalContentItemImg}&gt;
                &lt;DigitalTwinIcon /&gt;
              &lt;/div&gt;
              &lt;div className={s.Projects__modalContentItemName}&gt;
                Digital Twin
              &lt;/div&gt;
            &lt;/Link&gt;
          &lt;/div&gt;
        &lt;/Modal&gt;
      )}
      &lt;div className={s.Projects__content}&gt;
        &lt;div className={s.Projects__header}&gt;
          &lt;Heading variant={HeadingVariant.H2}&gt;Projects&lt;/Heading&gt;
          &lt;Button
            hoverVariant={ButtonVariant.ACTION}
            uppercase
            size=&quot;small&quot;
            leftIcon={&lt;AddIcon /&gt;}
            onClick={() =&gt; setModalOpen(true)}
          &gt;
            Create new project
          &lt;/Button&gt;
        &lt;/div&gt;
        {renderQueueProjects.length &gt; 0 &amp;&amp; (
          &lt;div className={s.Projects__renderQueue}&gt;
            &lt;Heading
              className={s.Projects__renderQueueHeader}
              variant={HeadingVariant.H3}
            &gt;
              Render queue
            &lt;/Heading&gt;
            &lt;div className={s.Projects__renderQueueWrapper}&gt;
              {renderQueueProjects.map((project) =&gt; (
                &lt;ProjectCard disabled key={project.name} project={project} /&gt;
              ))}
            &lt;/div&gt;
          &lt;/div&gt;
        )}
        &lt;Heading
          className={s.Projects__renderQueueHeader}
          variant={HeadingVariant.H3}
        &gt;
          All projects
        &lt;/Heading&gt;
        &lt;div className={s.Projects__projects}&gt;
          {projects
            .filter((p) =&gt; !p.isInRenderQueue)
            .map((project) =&gt; (
              &lt;ProjectCard key={project.name} project={project} /&gt;
            ))}
          &lt;div className={s.Projects__projectsPlaceholder} /&gt;
        &lt;/div&gt;
      &lt;/div&gt;
    &lt;/div&gt;
  );
};
</textarea><pre id="annotations" style="display:none">[{&quot;file&quot;:&quot;src/pages/projects/index.tsx&quot;,&quot;line&quot;:58,&quot;character&quot;:8,&quot;text&quot;:&quot;resObj&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/projects/index.tsx&quot;,&quot;line&quot;:60,&quot;character&quot;:10,&quot;text&quot;:&quot;data&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/projects/index.tsx&quot;,&quot;line&quot;:60,&quot;character&quot;:36,&quot;text&quot;:&quot;row as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/projects/index.tsx&quot;,&quot;line&quot;:61,&quot;character&quot;:4,&quot;text&quot;:&quot;resObj&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/projects/index.tsx&quot;,&quot;line&quot;:61,&quot;character&quot;:18,&quot;text&quot;:&quot;data&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/projects/index.tsx&quot;,&quot;line&quot;:61,&quot;character&quot;:31,&quot;text&quot;:&quot;acc&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/projects/index.tsx&quot;,&quot;line&quot;:61,&quot;character&quot;:36,&quot;text&quot;:&quot;a&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/projects/index.tsx&quot;,&quot;line&quot;:61,&quot;character&quot;:53,&quot;text&quot;:&quot;acc&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/projects/index.tsx&quot;,&quot;line&quot;:61,&quot;character&quot;:65,&quot;text&quot;:&quot;a&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/projects/index.tsx&quot;,&quot;line&quot;:63,&quot;character&quot;:9,&quot;text&quot;:&quot;resObj&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/projects/index.tsx&quot;,&quot;line&quot;:66,&quot;character&quot;:32,&quot;text&quot;:&quot;obj&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/projects/index.tsx&quot;,&quot;line&quot;:72,&quot;character&quot;:10,&quot;text&quot;:&quot;objWithNumbersAsKeys&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/projects/index.tsx&quot;,&quot;line&quot;:72,&quot;character&quot;:33,&quot;text&quot;:&quot;obj&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/projects/index.tsx&quot;,&quot;line&quot;:82,&quot;character&quot;:15,&quot;text&quot;:&quot;obj&quot;,&quot;kind&quot;:1}]</pre></div>
    <p class="footer-text">TypeScript Coverage Report generated by <a href="https://github.com/plantain-00/type-coverage">type-coverage</a> and <a href="https://github.com/alexcanessa/typescript-coverage-report">typescript-coverage-report</a> at Tue, 05 Oct 2021 23:09:04 GMT</p>
    </body>
  </html>
  